%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define _disable_ld_no_undefined 1
%define generate_rpmpriorities 0
%define comps %{_datadir}/comps/%{_build_arch}/comps.xml

%define aptver 0.5.15lorg3.95
%define snapver git522
%define srcver %{aptver}.%{snapver}
%define Werror_cflags %nil

%define _lib_name	%{name}-pkg
%define lib_name_orig	lib%{_lib_name}
%define major		0
%define libname		%mklibname %_lib_name %major
%define libnamedevel	%mklibname %_lib_name %major -d

%define _requires_exceptions rpmlib(PayloadIsLzma)\\|devel(linux-

Summary: Debian's Advanced Packaging Tool with RPM support
Name: apt
Version: %{aptver}
Release: %mkrel 11
Group: System/Configuration/Packaging
URL: http://apt-rpm.org/
License: GPLv2+ 
Source0: http://apt-rpm.org/testing/%{name}-%{srcver}.tar.xz

# user editable template configs
Source1: apt.conf
Source3: vendors.list
Source4: apt_preferences

# rpmpriorities generated + manually tweaked from comps.xml core group
Source5: rpmpriorities
Source19: comps2prio.xsl

# Sources 50-99 are for Lua-scripts not in contrib/
Source51: upgradevirt.lua
Source52: gpg-check.lua

# 150-199 for apt.conf.d
# "factory defaults"
Source150: default.conf

# band aid for mmap issues (#211254)
Patch1: apt-0.5.15lorg3.x-cache-corruption.patch

# fix format-security issue
Patch4: apt-0.5.15lorg3.95-format-security.patch

# Patch200 from Vine
Patch200:  apt-0.5.15lorg3.95-gcc47.patch

# revert patch
# http://apt-rpm.org/scm/?p=apt.git;a=commit;h=33283508cae4d598062561fe7c096238649adcba
# this commit breaks local package install...
Patch210: apt-0.5.15lorg3.95.git522-revert-mass-constify-rpmhandler-getter-methods.patch

# revert patch
# http://apt-rpm.org/scm/?p=apt.git;a=commit;h=0cc8fd20721f543bb8feb2cd98102dcc63c921b0
# http://apt-rpm.org/scm/?p=apt.git;a=commit;h=70f33318cc6a391a92f77a37a4f7773e6008dc36
# new genpkglist does not handle userfulFile correctly
Patch220: apt-0.5.15lorg3.95-revert-genbasedir.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

# TODO: verify the required minimum Python version
BuildRequires: python-devel >= 2.2
BuildRequires: libxml2-devel
BuildRequires: %{_lib}sqlite3-devel
BuildRequires: rpm-devel
BuildRequires: zlib-devel
BuildRequires: bzip2-devel
BuildRequires: libstdc++-devel
BuildRequires: gettext
BuildRequires: perl
BuildRequires: readline-devel
BuildRequires: ncurses-devel
BuildRequires: gawk
BuildRequires: git
BuildRequires: swig
%if %{generate_rpmpriorities}
BuildRequires: %{_bindir}/xsltproc
BuildRequires: %{comps}
%endif
BuildRequires: pkgconfig
BuildRequires: %{_lib}lua5.1-devel
BuildRequires: autoconf, automake
Requires: gnupg
Requires: bzip2
Requires(post): chkconfig
Requires(post): ldconfig
Requires(preun): chkconfig
Requires(pre): %{_lib}rpm1 >= 4.8.1
Requires(pre): rpm >= 4.8.1
Requires: %{libname} >= %version
Requires: apt-sources-list

%description
APT-RPM is a port of Debian's apt tools for RPM based distributions.
It provides the apt-get utility that provides a simple, safe way to
install and upgrade packages. APT features complete installation
ordering, multiple source capability and several other useful
features.

%package -n %{libname}
Summary:	Libraries for %{name}
Group:		System/Libraries
Provides:	%{lib_name_orig} = %{version}-%{release}
Requires:   	%name-common >= %version
Obsoletes:	libapt0.5
Provides:   	libapt0.5

%description -n %{libname}
This package contains APT's libapt-pkg package manipulation library
modified for RPM.

%package -n %{libnamedevel}
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	%{lib_name_orig}-devel
Obsoletes:	libapt0.5-devel
Provides:   	libapt0.5-devel

%description -n %{libnamedevel}
This package contains the header files and static libraries for
developing with APT's libapt-pkg package manipulation library,
modified for RPM.

%package python
Summary: Python bindings for libapt-pkg
Group: Development/python
Requires: %{name} = %{version}-%{release}

%description python
The apt-python package contains a module which allows python programs
to access the APT library interface.

%package common
Summary:	Common file for %{name} frontend
Group:		System/Configuration/Packaging

%description common
This package contains the needed files for various apt-frontend, 
such as synaptic, aptitude.

%prep
%setup -q -n %{name}-%{srcver}
%patch1 -p0 -b .mmap
%patch4 -p1 -b .format-security
%patch200 -p1 -b .gcc47
%patch210 -p1
%patch220 -p1

install -pm 644 %{SOURCE19} comps2prio.xsl

# don't require python, lua etc because of stuff in doc/contrib
find contrib/ -type f | xargs chmod 0644

%build

autoreconf -fi
%configure2_5x --disable-dependency-tracking --disable-static CPPFLAGS=-D_RPM_4_4_COMPAT

make %{?_smp_mflags}

make -C python %{?_smp_mflags} PYTHON="%{__python}"
python -O -c "import py_compile; py_compile.compile('python/apt.py')"

cp -p %{SOURCE5} rpmpriorities

%if %{generate_rpmpriorities}
xsltproc -o rpmpriorities comps2prio.xsl %{comps}
%endif

%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot} includedir=%{_includedir}/apt-pkg
%find_lang %{name}

# The state files
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/archives/partial
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/genpkglist
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/gensrclist
mkdir -p %{buildroot}%{_localstatedir}/lib/apt/lists/partial

# The config files
mkdir -p %{buildroot}%{_sysconfdir}/apt
mkdir -p %{buildroot}%{_sysconfdir}/apt/apt.conf.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/sources.list.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/vendors.list.d
install -pm 644 %{SOURCE1} %{buildroot}/%{_sysconfdir}/apt/apt.conf
install -pm 644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/apt/vendors.list
install -pm 644 %{SOURCE4} %{buildroot}/%{_sysconfdir}/apt/preferences
install -pm 644 rpmpriorities %{buildroot}/%{_sysconfdir}/apt/

# install config parts
install -pm 644 %{SOURCE150} %{buildroot}%{_sysconfdir}/apt/apt.conf.d/

# Lua scripts
mkdir -p %{buildroot}%{_datadir}/apt/scripts
for script in %{SOURCE51} %{SOURCE52} ; do
 install -pm 755 $script %{buildroot}%{_datadir}/apt/scripts
done

# The python bindings
mkdir -p %{buildroot}%{python_sitearch}/
install -pm 755 python/_apt.so %{buildroot}%{python_sitearch}/
install -pm 644 python/apt.py* %{buildroot}%{python_sitearch}/
touch %{buildroot}%{python_sitearch}/apt.pyo

# Nightly updater scripts & default config
install -Dpm 755 contrib/apt-cron/apt.init %{buildroot}/%{_initrddir}/apt
install -Dpm 755 contrib/apt-cron/apt.cron %{buildroot}/%{_sysconfdir}/cron.daily/apt.cron
install -Dpm 644 contrib/apt-cron/apt.sysconfig %{buildroot}/%{_sysconfdir}/sysconfig/apt

# nuke .la files
rm -f %{buildroot}%{_libdir}/*.la
rm -rf %{buildroot}/usr/lib/debug

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig
/sbin/chkconfig --add apt

%preun
if [ $1 -eq 0 ] ; then
 %{_initrddir}/apt stop &>/dev/null || :
 /sbin/chkconfig --del apt
fi

%postun
/sbin/ldconfig

%posttrans
#drop grub
perl -pi -e "s|grub||" %{_sysconfdir}/apt/rpmpriorities

%files -f %{name}.lang
%defattr(-, root, root)
%doc AUTHORS* COPYING* ABOUT* TODO comps2prio.xsl doc/examples/ contrib/
%doc ChangeLog
%{_bindir}/apt-cache
%{_bindir}/apt-cdrom
%{_bindir}/apt-config
%{_bindir}/apt-shell
%{_bindir}/apt-get
%{_bindir}/countpkglist
%{_bindir}/genpkglist
%{_bindir}/gensrclist
%{_bindir}/genbasedir
%{_mandir}/man[58]/*.[58]*

%files common
%defattr(-, root, root)
%{_libdir}/apt/
%{_localstatedir}/cache/apt/
%{_localstatedir}/lib/apt/
%dir %{_sysconfdir}/apt/
%config(noreplace) %{_sysconfdir}/apt/apt.conf
%config(noreplace) %{_sysconfdir}/apt/preferences
%config(noreplace) %{_sysconfdir}/apt/vendors.list
%config(noreplace) %{_sysconfdir}/apt/rpmpriorities

%dir %{_sysconfdir}/apt/apt.conf.d/

%config %{_sysconfdir}/apt/apt.conf.d/default.conf
%config %{_sysconfdir}/apt/apt.conf.d/multilib.conf

%dir %{_sysconfdir}/apt/sources.list.d/
%dir %{_sysconfdir}/apt/vendors.list.d/

%config(noreplace) %{_sysconfdir}/sysconfig/apt
%{_sysconfdir}/cron.daily/apt.cron
%{_initrddir}/apt

%dir %{_datadir}/apt/
%dir %{_datadir}/apt/scripts/
%{_datadir}/apt/scripts/gpg-check.lua
%{_datadir}/apt/scripts/upgradevirt.lua


%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %{libnamedevel}
%defattr(-,root,root)
%{_includedir}/apt-pkg
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%files python
%defattr(-,root,root,-)
%{python_sitearch}/_apt.so
%{python_sitearch}/apt.py*


%changelog
* Wed Dec 06 2017 Zen Subz <techars21 at gmail dot com> - 0.5.15lorg3.96-11pclos2017
- Rebuild with gcc7

* Wed Apr 27 2016 bb <bb> 0.5.15lorg3.96-10pclos2016
- drop cpu optimization

* Mon Apr 18 2016 bb <bb> 0.5.15lorg3.96-9pclos2016
- rebuild for updates

* Fri Apr 17 2015 bb <bb> 0.5.15lorg3.95-8pclos2015
- use revert patches 210 & 220 from vine

* Thu Apr 16 2015 bb <bb> 0.5.15lorg3.95-7pclos2015
- drop grub from rpmpriorities since we are moving to grub2
- update to git 522 

* Wed Nov 13 2013 pinoc <vogtpet at gmail.com>  0.5.15lorg3.95-6pclos2013
- add gcc-4.7 patch

* Mon Sep 26 2011 Texstar <texstar at gmail.com> 0.5.15lorg3.95-5pclos2011
- Split out sources.list into separate rpm package

* Sun Aug 14 2011 Texstar <texstar at gmail.com> 0.5.15lorg3.95-4pclos2011
- sources list for 64 bit
- rebuild against libreadline6

* Fri Jun 10 2011 Texstar <texstar at gmail.com> 0.5.15lorg3.95-3pclos2011
- rework package so same name as old versions

* Fri Jun 10 2011 Texstar <texstar at gmail.com> 0.5.15lorg3.95-2pclos2011
- fix rpm group and convert source to tar.xz

* Fri Jun 10 2011 Texstar <texstar at gmail.com> 0.5.15lorg3.95-1pclos2011
- update for 2011 release
